#ifndef ACCOUNT_H
#define ACCOUNT_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>

#include "date.H"
#include "money.H"

#define MAXX 5000  // maximum number of transactions per account
#define MAXDESC 40
#define MAXMEMO 40
#define MAXNAME 40
#define MAXNOTE 80
#define MAXNUMB 5

class Transaction {
  friend class Account;
  friend int Xcompare( const void *, const void * );
private:

public:
  char   szNumber[MAXNUMB + 1];
  Date   date;
  char   szDescription[MAXDESC + 1];
  char   szMemo[MAXMEMO + 1];
  Money  mnyCredit;
  Money  mnyDebit;
  bool   bRec;

  Money RecBalance;
  Transaction();
  Transaction( char *, Date, char *, char *, char *, Money, Money, bool );
  bool operator<( const Transaction & );
  bool operator==( const Transaction & );
  bool operator>( const Transaction & );
  void Tnum (char *);
  char *Tnum ();
  void Tdate (Date &);
  Date Tdate ();
  void Tsetdate (int m, int d, int y);
  void Tdesc (char *);
  char *Tdesc ();
  void Tmemo (char *);
  char *Tmemo ();
  void Trec (bool);
  bool Trec ();
};

class Account {
private:
  char    szName[MAXNAME + 1];
  char    szDesc[MAXDESC + 1];
  char    szNotes[MAXNOTE + 1];
  int     numTransactions;
  int     ptrTransaction;
  Transaction *xaction[MAXX];
  Money   Abalance;
  void    adjustBalance( int );
  unsigned int lastnbr;

public:

  Account();
  Account( char *Name, char *Desc, char *Notes );
  ~Account();
  void add( Transaction & );
  void del( int );
  void upd( int, Transaction & );
  void sort();

  Transaction *Xline( int );

  char *AccName();
  void AccName( const char * );
  char *AccDesc();
  void AccDesc( const char * );
  char *AccNotes();

  int Xnbr();
  
  unsigned int LastNbr () {return lastnbr;}
  void         LastNbr (unsigned int n) {lastnbr = n;}
  void         LastNbr (char *);
  
  Money A_recbal( int );
  Money A_balance();
  Money BankBalance();
};

#endif
