//---------------------------------------------------------
// Account Management - acctmngr.cc
//---------------------------------------------------------

#include "cheque.H"
#include <FL/fl_ask.H>
#include <string.h>

void ClearAccountMenu()
{
  mAccount->clear();
  if( numAcc == 0 )
    return;
  for( int i = 0; i < numAcc; i++ ) {
    delete acnt[i];
    acnt[i] = 0;
  }
  numAcc = 0;
}

void CreateAccountMenu()
{
  for( int i = 0; i < numAcc; i++ )
    mAccount->add( acnt[i]->AccName() );
  mAccount->value(0);
  mAccount->redraw();
}

void UpdateAccountMenu()
{
  mAccount->clear();
  CreateAccountMenu();
}

static int boolCreate = 0;
//declaration `CreateEditExit' with no type
static void CreateEditExit()
{
  wEditAccount->hide();
  boolCreate = 0;
  mAccount->redraw();
  loadBrowser();
}

void cb_AEcancel( Fl_Button *btn, void *data )
{
  if ( boolCreate == 1) {
    mAccount->remove( acctNbr );
    mAccount->value( 0 );
    mAccount->redraw();
    delete acnt[ acctNbr ];
    numAcc--;
    acctNbr = 0;    
  }
  CreateEditExit();
}

void cb_AEsave( Fl_Button *btn, void *data )
{
  if (strlen (inpAccountName->value()) == 0 )
    inpAccountName->value( "new account" );
  acnt[acctNbr]->AccName( inpAccountName->value() );
  acnt[acctNbr]->AccDesc( inpAccountDesc->value() );
  isDirty = true;
  if (boolCreate == 1) {
    mAccount->add( acnt[acctNbr]->AccName() );
    mAccount->value(acctNbr);
  } else {
    mAccount->replace( mAccount->value(), acnt[acctNbr]->AccName() );
    mAccount->redraw();  
  }
  CreateEditExit();
}

void cb_mCreateAccount( Fl_Menu_ *m, void *d )
{
  if( numAcc == MAXACCTS ) {
    fl_alert( "Max account limit reached" );
    return;
  }
  acctNbr = numAcc;
  numAcc++;
  acnt[acctNbr] = new Account();
  boolCreate = 1;
  acnt[acctNbr]->AccName( "new account" );
  cb_mEditAccount( m, d );
}

void cb_mDeleteAccount(Fl_Menu_*, void*)
{
  int delNbr = mAccount->value();
  if( numAcc == 0 ) return;
  if( fl_ask("Confirm Delete?" ) ) {
    mAccount->remove( delNbr );
    mAccount->value( 0 );
    mAccount->redraw();
    delete acnt[ delNbr ];
    for( int i = delNbr; i < numAcc; i++ )
      acnt[i] = acnt[i+1];
    numAcc--;
    isDirty = true;
    acctNbr = 0;
    loadBrowser();
  }
}

void cb_mEditAccount(Fl_Menu_*, void*)
{
  if (numAcc == 0) return;
  inpAccountName->value( (char *)acnt[acctNbr]->AccName() );
  inpAccountDesc->value( (char *)acnt[acctNbr]->AccDesc() );
  wEditAccount->show();
}

void cb_bOAcancel( Fl_Button *b, void *d )
{
  wNewFile->hide();
  activateButtons();
}

void cb_bOAsave( Fl_Button *b, void *d )
{
  const char *str1, *str2, *str3;
  str1 = inpDataFileName->value();
  str2 = inpOpeningAccountName->value();
  str3 = inpOpeningAccountDesc->value();

  if ( str1 != 0 && *str1 != 0 && str2 != 0 && *str2 != 0 ) {
    ClearAccountMenu();
    wBrowser->clear();
    if( numAcc == MAXACCTS ) {
      fl_alert( "Max account limit reached" );
      wNewFile->hide();
      return;
    }
    strcpy( szFLCfile, str1 );
    numAcc = 1;
    acctNbr = 0;
    acnt[0] = new Account();
    acnt[0]->AccName( str2 );
    acnt[0]->AccDesc( str3 );
    mAccount->add( acnt[acctNbr]->AccName() );
    mAccount->value(0);
    mAccount->redraw();
    isDirty = true;
    SetTitle();
  }
  wNewFile->hide();
  activateButtons();
}

void cb_mNew( Fl_Menu_ *m, void *d )
{
  inpDataFileName->value("");
  inpOpeningAccountName->value("");
  inpOpeningAccountDesc->value("");
  wNewFile->show();
}

