// ====================================================================
//
//  Fast Light Took Kit Checkbook Program
//
//  Copyright (C) 1998 David Freese                                  
//                                                                   
//  This program is free software; you can redistribute it and/or    
//  modify it under the terms of the GNU General Public License as   
//  published by the Free Software Foundation; either version 2 of   
//  the License, or (at your option) any later version.              
//                                                                   
//  This program is distributed in the hope that it will be useful,  
//  but WITHOUT ANY WARRANTY; without even the implied warranty of   
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
//  GNU General Public License for more details.                     
//                                                                   
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software      
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.        
//                                                                   
//    Author: Dave Freese                                            
//  Internet: dfreese@intrepid.net                                   
//                                                                   
// ====================================================================

#include "cheque.H"
#include <FL/fl_ask.H>
#include <string.h>

bool autonumber = true;

int editNbr = 0;
int acctNbr = 0;
int  editMode = 0;

char szFLCfile[128] = "temp.flc";
bool isDirty = false;

void loadBrowser();

void SaveTransaction()
{
  char s[81];
  Transaction pX;
  int mm, dd, yy, n;
  Money dVal;

  if( editNbr < 0 ) return;
  if( !acnt[ acctNbr ] ) return;

  if( acnt[ acctNbr ]->Xline(editNbr)->Trec() == true ) {
    if( !fl_ask("Reconciled! CONFIRM UPDATE ?" ) )
      return;
  } else 
    if( acnt[acctNbr]->Xline(editNbr)->Trec() != chkRec->value() ) {
      if( !fl_ask("CONFIRM Reconcile CHANGE ?" ) )
        return;
    }

  isDirty = true;

  pX.Tnum( (char *)wNbr->value() );

  n = sscanf( wDate->value(),"%d/%d/%d", &mm, &dd, &yy );
  if( n == 3 )
    pX.date.setDate( mm, dd, yy > 50 ? yy + 1900 : yy + 2000 );

  pX.Tdesc( (char *)wDesc->value() );

  if( ( dVal = Money( wDebit->value() ) ) > 0.0 ) {
    pX.mnyDebit = dVal;
    pX.mnyCredit = 0.0;
  } else {
    pX.mnyCredit = Money( wCredit->value() );
    pX.mnyDebit = 0.0;
  }

  pX.Tmemo( (char *)wMemo->value() );

  if( chkRec->value() == true )
    pX.Trec( true );
  else
    pX.Trec( false );

  acnt[ acctNbr ]->upd( editNbr, pX );
}

void EditTransaction( int i )
{
  Transaction *pX;

  if( !acnt[ acctNbr ] ) return;

  pX = acnt[ acctNbr ]->Xline(i);
  if( !pX ) return;

  wNbr->value ( pX->Tnum() );
  wDate->value ( pX->Tdate().szDate() );
  wDesc->value ( pX->Tdesc() );
  wCredit->value ( szMoney( pX->mnyCredit, 8 ) );
  wDebit->value ( szMoney( pX->mnyDebit, 8 ) );
  wMemo->value ( pX->Tmemo() );

  if( pX->Trec() == true )
    chkRec->set();
  else
    chkRec->clear();

  txtLineBalance->value( szMoney( acnt[ acctNbr ]->A_recbal(i), 8 ) );
  txtBalance->value( szMoney( acnt[ acctNbr ]->A_balance(), 8 ) );
  txtStatementBal->value( szMoney( acnt[ acctNbr ]->BankBalance(), 8 ) );

  editGroup->show();

  wBrowser->value( i + 1 );
  if( wBrowser->size() < 19 ) {
    wBrowser->topline( 1 );
    return;
  }
  else if( i > (wBrowser->size() - 9 ) )
    wBrowser->topline( wBrowser->size() - 18 );
  else
    wBrowser->topline( i - 8 );

}


char *BrowserLine( int i, Transaction *pX )
{
  static char buffer[256];
  char temp[80],
       *color1 = "@C0@.",
       *color2 = "@C4@.";
  memset( buffer, 0, 256 );
  memset (temp, 0, 80);
  sprintf( buffer, "@_%s%4s|", 
           ( i % 2 ? color1 : color2 ),
           pX->Tnum() );
  sprintf( temp,"%s|", pX->Tdate().szDate(4) );
  strcat( buffer, temp );
  sprintf( temp,"%-30s", pX->Tdesc() );  temp[30] = '|'; temp[31] = 0;
  strcat( buffer, temp );
  strcat( buffer, ( pX->Trec() ? "y|" : "n|" ) );
  if( pX->mnyDebit > 0.0 )
    sprintf( temp, "%9s|         |", 
             szMoney (pX->mnyDebit, 8) ); // either dCredit or dDebit
  else
    sprintf( temp,"         |%9s|",  
             szMoney (pX->mnyCredit, 8) );
  strcat( buffer, temp );
  sprintf( temp, "%10s", szMoney (pX->RecBalance, 9) );
  strcat( buffer, temp );
  return buffer;
}

void activateButtons()
{
  if( acnt[acctNbr]->Xnbr() == 0 ) {
    if (editMode == 1)
      bSave->activate ();
    else
      bSave->deactivate ();
    bDelete->deactivate ();
    ClearTransaction();
  } else {
    bSave->activate ();
    if (editMode == 1)
      bDelete->deactivate ();
    else
      bDelete->activate ();
    EditTransaction (editNbr);
  }
}

void loadBrowser()
{
  Transaction *pX;
  int num;

  if( !acnt[ acctNbr ] ) return;

  wBrowser->clear();
  wBrowser->redraw();

  wDesc->clear_cbo();
  wMemo->clear_cbo();

  num = acnt[acctNbr]->Xnbr();

  if( num ) {

    acnt[acctNbr]->sort();

    for( int i = 0; i < num; i++ ) {
      pX = acnt[ acctNbr ]->Xline(i);
      if( pX ) {
        wBrowser->add( BrowserLine( i, pX ) );
        wDesc->add( pX->Tdesc() );
        wMemo->add( pX->Tmemo() );
      }
    }
    wDesc->sort();
    wMemo->sort();

    editNbr = num - 1;
  }
  activateButtons();
}

void workingAccount( Fl_Choice *w, void *d )
{
  acctNbr = mAccount->value();
  loadBrowser();
}

void SetTitle()
{
  char title[128];
  strcpy( title, "Lightning Cheque: " );
  strncat( title, szFLCfile, 20 );
  wMain->label( title );
}

void readfile( char *p )
{
  strcpy( szFLCfile, p );
  ClearAccountMenu();
  if( readData( szFLCfile ) ) {
    CreateAccountMenu();
    acctNbr = 0;
    loadBrowser(); // start with account 0
    SetTitle();
  }
}

void cb_mOpenFile(Fl_Menu_ *w, void *d) 
{
  char *p;
  p = fl_file_chooser("Select FLC File", "*.flc", "" );
  if (p && *p )
    readfile( p );
}

void cb_mImportFLC( Fl_Menu_ *w, void *d )
{
  char *p;
  p = fl_file_chooser("Select FLC File", "*.flc", "");
  if (p && *p ) {
    importData( p );
    UpdateAccountMenu();
    acctNbr = 0;
    loadBrowser(); // start with account 0
    SetTitle();
  }
}


void cb_mImportCSV( Fl_Menu_ *w, void *d )
{
extern int ImportCSV();
  if (ImportCSV() == 1) {
    UpdateAccountMenu();
    acctNbr = 0;
    loadBrowser(); // start with account 0
    SetTitle();
  }
}

void cb_mExportCSV (Fl_Menu_ *w, void *d)
{
extern void ExportCSV();
  ExportCSV();
}

void SaveFile()
{
  if( isDirty ) {
    if( szFLCfile[0] == 0 ) strcpy( szFLCfile, "noname.flc" );
    writeData( szFLCfile );
  }
  isDirty = false;
}

void cb_mSaveFile( Fl_Menu_ *w, void *d)
{
  SaveFile();
}

void cb_mSaveFileAs( Fl_Menu_ *w, void *d )
{
  char *p;
  p = fl_file_chooser("Save As FLC File", "*.flc", "" );
  if( p && *p ) {
    strcpy( szFLCfile, p );
    writeData( szFLCfile );
  }
  isDirty = false;
}

void BrowserDblClick_cb( Fl_Browser *o, void *d )
{
  editNbr = o->value() - 1;
  EditTransaction( editNbr );
}


void btnNext_cb( Fl_Button *o, void *d )
{
  if( acnt[ acctNbr ]->Xnbr() && ( editNbr < (acnt[ acctNbr ]->Xnbr() -1) ) )
    EditTransaction( ++editNbr );
}

void btnLast_cb( Fl_Button *o, void *d )
{
  if( acnt[ acctNbr ]->Xnbr() )
    EditTransaction( ( editNbr = acnt[ acctNbr ]->Xnbr() - 1 ) );
}

void btnPrev_cb( Fl_Button *o, void *d )
{
  if( editNbr > 0 )
    EditTransaction( --editNbr );
}

void btnFirst_cb( Fl_Button *o, void *d )
{
  if( acnt[ acctNbr ]->Xnbr() )
    EditTransaction( ( editNbr = 0 ) );
}

void cb_Delete( Fl_Button *o, void *d )
{
  int delnbr = editNbr;
  if (!fl_ask("CONFIRM DELETE ?" ) )
      return;
  if (editNbr >= 0) {
    acnt[acctNbr]->del(delnbr);
    loadBrowser();
    activateButtons();
    isDirty = true;
    EditTransaction( editNbr );
  }
}

void cb_SaveRecord( Fl_Button *o, void *d )
{
  int enbr = editNbr;
  if( editMode == 1 ) {
    Transaction X;
    acnt[acctNbr]->add(X);
    editNbr = enbr = acnt[acctNbr]->Xnbr()-1;
    editMode = 0;
    bNew->label("New");
    bNew->redraw();
    bSave->label("Update");
    bSave->redraw();
  }
  SaveTransaction();
  loadBrowser();
  editNbr = enbr;
  EditTransaction( editNbr );
}

void ClearEditFields()
{
  char s[20];
  Date today;

  wNbr->value( "" );
    
  sprintf( s,"%02d/%02d/%02d", 
    today.Month(),
    today.Day(),
    today.Year() < 2000 ? today.Year() - 1900 : today.Year() - 2000 );
  wDate->value( s );
  
  wDesc->value( "" );
  wCredit->value( szMoney( Money(), 8) );
  wDebit->value( szMoney( Money(), 8) );
  wMemo->value( "" );
  chkRec->clear();
  txtLineBalance->value( "" );
  txtBalance->value( "" );
  txtStatementBal->value( "" );
}

void ClearTransaction()
{
  ClearEditFields ();
  Fl::focus (wNbr);
  editGroup->show ();
}

void NewTransaction()
{
  char s[20];
  ClearEditFields ();
  if (autonumber) {
    sprintf (s,"%d", acnt[acctNbr]->LastNbr() + 1);
    wNbr->value (s);
  }
  Fl::focus (wNbr);
  editGroup->show ();
}

void cb_New( Fl_Button *o, void *d )
{
  if( editMode == 0 ) {
    editMode = 1;
    bNew->label("cancel");
    bNew->redraw();
    bSave->label("Save");
    bSave->redraw();
    activateButtons ();
    NewTransaction();
  } else {  
    editMode = 0;
    bNew->label("New");
    bNew->redraw();
    bSave->label("Update");
    bSave->redraw();
    activateButtons ();
    EditTransaction( editNbr );
  }
}

void cleanExit()
{
  if( isDirty == false )
    exit(0);
  if( fl_ask( "Account changed!\nDo you want to save the changes?" ) )
    SaveFile();
  exit(0);
}

void cb_mExit( Fl_Menu_ *mnu, void *d )
{
  cleanExit();
}

void cb_wMain( Fl_Widget *, void * ) 
{
  cleanExit();
}

void cb_bCreate (Fl_Button *, void *)
{
  wCreateOpen->hide();
  inpDataFileName->value("");
  inpOpeningAccountName->value("");
  inpOpeningAccountDesc->value("");
  wNewFile->show();
}

void cb_bOpen (Fl_Button *, void *)
{
  char *p;
  wCreateOpen->hide();
  p = fl_file_chooser("Select FLC File", "*.flc", "" );
  if (p && *p )
    readfile( p );
}

void cb_bCancel (Fl_Button *, void *)
{
  wCreateOpen->hide();
}

bool  AUTOSAVE = true;
float SAVE_TIMEOUT = 1.0;

void cb_timer(void *d)
{
  if (AUTOSAVE == false) return;
  if (isDirty == true) {
    SaveFile();
  }
  Fl::add_timeout (SAVE_TIMEOUT * 60.0, cb_timer);  
}

void initXfrFunds ()
{
  cboXfrFrom->clear_cbo ();
  cboXfrTo->clear_cbo ();
  cboXfrCategory->clear_cbo ();
  for (int i = 0; i < numAcc; i++) {
    cboXfrFrom->add (acnt[i]->AccName());
    cboXfrTo->add (acnt[i]->AccName());
  }
  Transaction *pX;
  int num = acnt[acctNbr]->Xnbr();
  for (int i = 0; i < num; i++) {
    pX = acnt[ acctNbr ]->Xline(i);
    if( pX )
      cboXfrCategory->add( pX->Tmemo() );
  }
  cboXfrCategory->sort ();
  Date today;
  txtXfrDate->value( today.szDate () );
  txtXfrAmount->value ("");
}


void doXfrFunds()
{
  Transaction pX;
  int mm, dd, yy, n, aTo, aFm;
  Money dVal;

  isDirty = true;

  pX.Tnum ("EFT");
  n = sscanf( txtXfrDate->value(),"%d/%d/%d", &mm, &dd, &yy );
  if( n == 3 )
    pX.date.setDate( mm, dd, yy > 50 ? yy + 1900 : yy + 2000 );
  pX.Tdesc ("Funds Transfer");
  pX.Tmemo( (char *)cboXfrCategory->value() );
  pX.Trec( false );

// modify "From Account"
  dVal = Money( txtXfrAmount->value() );
  pX.mnyDebit = dVal;
  pX.mnyCredit = 0.0;
  aFm = cboXfrFrom->itemnbr() -1;
  n = acnt[aFm]->Xnbr();
  acnt[aFm]->add (pX);

// modify "To Account"
  pX.mnyCredit = dVal;
  pX.mnyDebit = 0.0;
  aTo = cboXfrTo->itemnbr() - 1;
  n = acnt[aTo]->Xnbr();
  acnt[aTo]->add (pX);
  
// reload the browser for current account
  loadBrowser ();
}

int main(int argc, char **argv) {
  Fl_Window *wMain = create_main();

  wMain->callback( cb_wMain );

  wMain->show();

  if( argc == 2 )
    readfile( argv[1] );
  else
    wCreateOpen->show();
    
  Fl::add_timeout (SAVE_TIMEOUT * 60.0, cb_timer);

  return Fl::run();
}
