// logplot.h
#ifndef LOGPLOT_H
#define LOGPLOT_H

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Counter.H>
#include <FL/fl_draw.H>
#include <FL/math.h>
#include <stdio.h>

#include "date.H"

class MDPlot : public Fl_Widget {
  double yrsMin, yrsMax;
  double mnyMax, mnyMin;
  void draw();
  void PlotMny();
  void PlotSlidingAvg();
  
public:
  MDPlot(int X,int Y,int W,int H) : Fl_Widget(X,Y,W,H)
  {
    box( FL_BORDER_FRAME );
    yrsMin = 1995;
    yrsMax = 2000;
    mnyMax = 10000.0;
    mnyMin = 0.0;
  }
  double MnyMin();
  void MnyMin( double val );
  double MnyMax();
  void MnyMax( double val );
  double YrsMax();
  void YrsMax( double val );
  double YrsMin();
  void YrsMin( double val );
  void end() {};
};

#endif
