// ====================================================================
//
//  reconcile.cc Fast Light Took Kit Checkbook Program
//               reconciliation functions
//
//  Copyright (C) 1998 David Freese                                  
//                                                                   
//  This program is free software; you can redistribute it and/or    
//  modify it under the terms of the GNU General Public License as   
//  published by the Free Software Foundation; either version 2 of   
//  the License, or (at your option) any later version.              
//                                                                   
//  This program is distributed in the hope that it will be useful,  
//  but WITHOUT ANY WARRANTY; without even the implied warranty of   
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
//  GNU General Public License for more details.                     
//                                                                   
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software      
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.        
//                                                                   
//    Author: Dave Freese                                            
//  Internet: dfreese@intrepid.net                                   
//                                                                   
// ====================================================================

#include "cheque.H"
#include <stdlib.h>

Money recdiff;

void showRecBal( Money d )
{
  Account *pA = acnt[ acctNbr ];
  char s[10];
  Money StatementDiff = pA->BankBalance() - Money(dRecBalance->value());
  recDifference->value( szMoney( StatementDiff - d, 8 ) );
}

void cb_dRecBalance( Fl_Input *v, void *data )
{
  showRecBal( recdiff );
}

void cb_recBrowser( Fl_Browser *brws, void *data )
{
  char s[80];
  char szAmt[10];
  Money mAmt;
  int n = brws->value();
  if (!n )
    return;
  strcpy( s, brws->text(n) );
  s[0] = (s[0] == ' ') ? 'x' : ' ';
  brws->replace( n, s );
  sscanf( &s[7], " %8s|", szAmt );
  mAmt = Money (szAmt);
  switch( brws == recCredits ) {
    case true :
      if( s[0] == 'x' ) recdiff -= mAmt;
      else              recdiff += mAmt;
      break;
    case false :
      if( s[0] == 'x' ) recdiff += mAmt;
      else              recdiff -= mAmt;
      break;
  }
  showRecBal( recdiff );
}

void cb_OK( Fl_Button *b, void *d )
{
  Account *pA = acnt[ acctNbr ];
  Transaction *pX;
  int recnbr;
  int numrecs;

  wBrowser->deactivate();
  numrecs = recCredits->size();

//fprintf(stderr, "numrec = %d\n", numrecs ); fflush(stderr);

  for(int i = 1; i < numrecs; i += 2 )
    if( (recCredits->text(i))[0] == 'x' ) {
      recnbr = atoi( recCredits->text(i+1) );
      pX = pA->Xline( recnbr );
      pX->Trec( true );
      wBrowser->replace( recnbr + 1, BrowserLine( recnbr, pX ) );
    }
  numrecs = recDebits->size();

//fprintf(stderr, "numrec = %d\n", numrecs ); fflush(stderr);

  for(int i = 1; i < numrecs; i += 2 )
    if( (recDebits->text(i))[0] == 'x' ) {
      recnbr = atoi( recDebits->text(i+1) );
      pX = pA->Xline( recnbr );
      pX->Trec( true );
      wBrowser->replace( recnbr + 1, BrowserLine( recnbr, pX ) );
    }
  wBrowser->activate();
  wReconcile->hide();
  EditTransaction( editNbr );
}

void addCreditRecLine( int nbr, Transaction *pX )
{
  char s[80], *szNum, *szDesc;
  Money dAmt;
  szNum = pX->Tnum();
  dAmt = pX->mnyCredit;
  szDesc = pX->Tdesc();
  sprintf( s, " |%4s|%s|%.30s", szNum, szMoney(dAmt, 8), szDesc );
  recCredits->add( s );
  sprintf( s, "%d", nbr );
//second line is hidden & contains the record #
  recCredits->add( s );
  recCredits->display( recCredits->size(), 0 );
}

void addDebitRecLine( int nbr, Transaction *pX )
{
  char s[80], *szNum, *szDesc;
  Money dAmt;
  szNum = pX->Tnum();
  dAmt = pX->mnyDebit;
  szDesc = pX->Tdesc();
  sprintf( s, " |%4s|%s|%.30s", szNum, szMoney(dAmt, 8), szDesc );
  recDebits->add( s );
//second line is hidden & contains the record #
  sprintf( s, "%d", nbr );
  recDebits->add( s );
  recDebits->display( recDebits->size(), 0 );
}

void cb_mReconcile( Fl_Menu_ *m, void *data )
{
  Account *pA = acnt[ acctNbr ];
  Transaction *pX;
  int numX = pA->Xnbr();
  char s[10], **sV;

  recDebits->type(Fl_Browser_::BOTH_ALWAYS);
  recCredits->type(Fl_Browser_::BOTH_ALWAYS);

  recDebits->clear();
  recCredits->clear();
  recdiff = 0.0;

  showRecBal( recdiff );

  for( int i = 0; i < numX; i++ ) {
    pX = pA->Xline(i);
    if( pX->Trec() == false ) {
      if( pX->mnyCredit > 0.0 )
        addCreditRecLine( i, pX );
      else
        addDebitRecLine( i, pX );
    }
  }
  recDebits->topline(1);
  recCredits->topline(1);
  wReconcile->show();
}


